unit bugServiceApplication;

interface
uses
  Classes,bugFrmService,bugService;

var
  svcService: TAFService;

procedure ApplicationSetup(pstrApplicationName: String; pfrmVar: TFrmService; pclsFrmType: TComponentClass);
implementation
uses
  Forms,
  svcMgr,
  Windows,
  SysUtils,
  WinSvc,
  bugsvcCnst;

var
  strServiceName: String;
  strApplicationName: String;
  strApplicationMutex: String;

//svcinstall
function Installing: Boolean;
begin
  Result := FindCmdLineSwitch('INSTALL',['-','\','/'], True) or
            FindCmdLineSwitch('UNINSTALL',['-','\','/'], True);
end;

//svcstart
function StartService: Boolean;
var
  vintMgr, vintSvc: Integer;
  vstrUserName, vstrServiceStartName: string;
  vptrConfig: Pointer;
  vdwdSize: DWord;
begin
  Result := False;
  vintMgr := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
  if vintMgr <> 0 then
  begin
    vintSvc := OpenService(vintMgr, PChar(strServiceName), SERVICE_ALL_ACCESS);
    Result := vintSvc <> 0;
    if Result then
    begin
      QueryServiceConfig(vintSvc, nil, 0, vdwdSize);
      vptrConfig := AllocMem(vdwdSize);
      try
        QueryServiceConfig(vintSvc, vptrConfig, vdwdSize, vdwdSize);
        vstrServiceStartName := PQueryServiceConfig(vptrConfig)^.lpServiceStartName;
        if CompareText(vstrServiceStartName, 'LocalSystem') = 0 then
          vstrServiceStartName := 'SYSTEM';
      finally
        Dispose(vptrConfig);
      end;
      CloseServiceHandle(vintSvc);
    end;
    CloseServiceHandle(vintMgr);
  end;
  if Result then
  begin
    vdwdSize := 256;
    SetLength(vstrUserName, vdwdSize);
    GetUserName(PChar(vstrUserName), vdwdSize);
    SetLength(vstrUserName, StrLen(PChar(vstrUserName)));
    Result := CompareText(vstrUserName, vstrServiceStartName) = 0;
  end;
end;

procedure ApplicationSetup(pstrApplicationName: String; pfrmVar: TFrmService; pclsFrmType: TComponentClass);
begin

  strServiceName := ExtractFileName(ParamStr(0));
  strServiceName := ChangeFileExt(strServiceName,'');
  strApplicationName := pstrApplicationName + ' (' + strServiceName + ')';
  strApplicationMutex := Lowercase(strServiceName);

  {if not Installing then
  begin
    CreateMutex(nil, True, PChar(strApplicationMutex));
    if GetLastError = ERROR_ALREADY_EXISTS then
    begin
      MessageBox(0, 'Service Already Running', PChar(strApplicationName), MB_ICONERROR);
      Halt;
    end;
  end;  }

  if Installing or StartService then
  begin
    //svcsvc svc
        SvcMgr.Application.Initialize;
        svcService := TAFService.CreateNewCustom(SvcMgr.Application, strApplicationName, strServiceName, 0);
        SvcMgr.Application.CreateForm(pclsFrmType, pfrmVar);
        svcService.MessageHandle := pfrmVar.Handle;
        SvcMgr.Application.Run;
  end else
  begin
        Forms.Application.ShowMainForm := False;
        Forms.Application.Initialize;
        Forms.Application.CreateForm(pclsFrmType, pfrmVar);
        pfrmVar.Initialize(False);
        Forms.Application.Run;
  end;
end;

end.
